=== debian/changelog ===
glslang (16.0.0-1) unstable; urgency=medium

  * New upstream release.
  * control: Migrate to spirv-tools-dev, bump version.
  * patches: Refreshed.
  * install: Drop spirv-remap, removed upstream.

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 10 Nov 2025 13:16:46 +0200
