=== debian/watch ===
version=4

https://github.com/KhronosGroup/glslang/tags \
.*/v?(\d\S*)\.tar\.gz
