## glslang 16.1.0

=== debian/changelog ===
glslang (16.1.0-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump spirv-tools depends.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 18 Dec 2025 11:49:53 +0200

glslang (16.0.0-3) unstable; urgency=medium

  [ Dylan Aïssi ]
  * autopkgtest: don't test spirv-remap which is now part of spirv-opt
    (from spirv-tools)

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 05 Dec 2025 15:49:07 +0200

glslang (16.0.0-2) unstable; urgency=medium

  * patches: Clean up remnants of SPVRemapper.

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 05 Dec 2025 09:50:46 +0200
