=== debian/changelog ===
glslang (16.2.0-2) unstable; urgency=medium

  * rules: Add armhf to the list of archs to skip tests on, until we
    have a fix. (Closes: #1128774)

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 27 Feb 2026 09:22:36 +0200

glslang (16.2.0-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump spirv-tools depends.

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 06 Feb 2026 11:24:52 +0200
